#define __EXC_INTERNAL
#include <exc.h>

#if defined(__HIGHC__)
#pragma On(call_trace)
#endif

void foo_5 (char x) { *(int*)-1 = 0; }  /* cause exception, unwind */
void foo_4 (char x) { foo_5 (5); }      /* stack back to main()    */
void foo_3 (char x) { foo_4 (4); }
void foo_2 (char x) { foo_3 (3); }
void foo_1 (char x) { foo_2 (2); }

int main (void)
{
  excCoreFile = 0;
  InstallExcHandler (NO_EXC_HOOK);
  foo_1 (1);
  return (0);
}

#if defined(__HIGHC__)
  #pragma Off(call_trace)

  void _call_trace (char *from, char *module, unsigned line, char *to)
  {
    printf ("%s (%u): %s() -> %s()\n", module,line,from,to);
  }
#endif

