#
# Makefile (Borland make) for HighC/Pharlap exception handler library
#

MAKE = maker.exe
ZIP  = zip386 -g9@

all:
  cd .\src
  $(MAKE) -f Makefile.hc
  cd ..\demo
  $(MAKE) -f Makefile.hc
  cd ..

clean:
  cd .\src
  $(MAKE) -f Makefile.hc clean
  cd ..\demo
  $(MAKE) -f Makefile.hc clean
  cd ..

zip:
  $(ZIP) zip\exc_dx06 < &&|
    read.me
    file_id.diz
    makefile.*
    *.h
    lib\exc_*.lib
    lib\libexc.a

    demo\makefile.*
    demo\demo_?.asm
    demo\demo_?.c
    demo\demo_?.exp
    demo\demo_2.txt
    demo\demo_9.cc
    demo\descr.c
    demo\rm_test.c
    demo\seh_test.c
    demo\descr.exp
    demo\exp_dmp.exp

    src\makefile.*
    src\*.[ch]
    src\demangle.man
    src\uasm.mtx

    src\djgpp\*.[ch]
    src\pharlap\*.[ch]
    src\pharlap\*.asm
    src\pharlap\exc.inc

    src\obj\djgpp\delete.me
    src\obj\highc\delete.me
    src\obj\dos4g.w3r\delete.me
    src\obj\pharlap.w3r\delete.me
    src\obj\dos4g.w3s\delete.me
    src\obj\pharlap.w3s\delete.me
|

