#ifndef __IOPORT_H
#define __IOPORT_H

/*
 * Macros necessary to bypass the limitation of Borland's BCC32 not
 * to allow inline port functions. Assignements should be volatile,
 * check the .asm output.
 * NB! macro-args must be TASM/MASM compatible
 */

#if defined(__FLAT__) && defined(__BORLANDC__)
#  define VOLATILE        volatile
#  define __in(p,t,z)     (_DX=(USHORT)(p),__emit__(0xEC+z),(unsigned t)_AX)
#  define __out(p,x,z)    {_AX=(USHORT)(x);_DX=(USHORT)(p);__emit__(0xEE+z);}
#  define _inportb(p)     __in(p,char,0)
#  define _inportw(p)     __in(p,short,1)
#  define _outportb(p,x)  __out(p,x,0)
#  define _outportw(p,x)  __out(p,x,1)

#elif defined (__HIGHC__)
#  include <conio.h>
#  define _inportb(p)     _inb(p)
#  define _inport(p)      _inw(p)
#  define _outportb(p,x)  _outb(p,x)
#  define _outportw(p,x)  _outpw(p,x)
#  define VOLATILE

#else
#  define __INLINE_FUNCTIONS__ /* makes Watcom inline I/O instructions */
#  include <conio.h>

#  define _inportb(p)     inp(p)
#  define _inport(p)      inpw(p)
#  define _outportb(p,x)  outp(p,x)
#  define _outportw(p,x)  outpw(p,x)
#  define VOLATILE
#endif

#endif
