PAGE 60,132

ifdef ??version           ; using TASM 
  masm
endif

.486

ExcStruc struc            ; exception handling context structure definition
     excNum  dd  0        ; public in exc_0.asm, filled by exc_0 when
     excCode dd  0        ; exception occurs
     _DS     dw  0,0
     _ES     dw  0,0
     _FS     dw  0,0
     _GS     dw  0,0
     _SS     dw  0,0
     _CS     dw  0,0
     _EIP    dd  0
     _EAX    dd  0
     _EBX    dd  0
     _ECX    dd  0
     _EDX    dd  0
     _ESI    dd  0
     _EDI    dd  0
     _EFlags dd  0
     _ESP    dd  0
     _EBP    dd  0
     _CR0    dd  0
     _CR2    dd  0
ExcStruc ends

try_excBlk struc          ; internal __try/__except block used by
     exceptFlag  dd 0     ; Borland's BCC32 (and others ??)
     exceptTOS   dd 0     ; ESP in __try block
     unknown_    dw 0,0   ; ??
     excAction   dd 0     ; __except() value or proc address
     exceptPoint dd 0     ; __except() block start address
try_excBlk  ends

PMRM_INTR struc
     number      dd 0     ; interrupt number
     call_back   dd 0     ; callback function
     rmVector    dd 0     ; old rmode vector
     pmVector    dp 0     ; old pmode vector
PMRM_INTR ends


jmp_buf equ <ExcStruc>    ; same structure used for setjmp/longjmp in seh_1.c
RetFar  equ <db 0CBh>     ; PharLap 386|ASM doesn't have this

SS_CODE   = 0Ch
SS_DATA   = 14h
SS_DOSMEM = 34h
SS_SCREEN = 1Ch
NUM_EX    = 18            ; hardware exception vectors 0 - 17
                          ; software signals >= 18

C_PROC MACRO name
       align 4
       public _&name, @_&name
       @_&name label near              ; for MetaWare/Watcom
       _&name  label near              ; for all others
       endm    

PUB_DW MACRO name, val
       public _&name, @_&name
      _&name   label word
       @_&name dw val
       endm    

PUB_DD MACRO name, val
       public _&name, @_&name
      _&name   label dword
       @_&name dd val
       endm    

;------------------------------------------------------------------

_DATA SEGMENT PUBLIC DWORD USE32 'DATA'
_DATA ENDS

_TEXT SEGMENT PUBLIC DWORD USE32 'CODE'
_TEXT ENDS

ASSUME CS:_TEXT, DS:_DATA, SS:_DATA

